Skip to main content

Route points

Starting and ending points

For public transport, the starting and ending route points are specified in the separate parameters source and target:

{
"source":
{
"point":
{
"lat": 55.798227,
"lon": 37.697461
}
},
"target":
{
"point":
{
"lat": 55.821029,
"lon": 37.641507
}
},
}

For other transportation types, the starting and ending points are specified in the points array. You can specify multiple starting and ending points. This can be useful in cases where a building has multiple entrances and exits. In this case, an optimal route from one of the starting points to one of the ending points is built.

By default, the first point in the array is considered as the starting one. You can also explicitly specify the starting point using the start parameter:

{
"points": [
{
"lon": 37.582591,
"lat": 55.775364,
"type": "stop",
"start": true
},
{
"lon": 37.656625,
"lat": 55.765036,
"type": "stop"
}
]
}

Additionally, you can pass multiple pairs of starting and ending points to the points array to build routes for multiple point pairs in one request.

Point types

For each point, it is recommended to explicitly specify its type using the type parameter:

  • walking - starting or ending point of the route.

    • For pedestrian routes: using only this point type is recommended.
    • For transport routes: if the point is not located on a road, a pedestrian path avoiding obstacles (such as buildings) is added to the route.
  • stop - starting or ending point of the route. If in the transport route the point is not located on a road, a direct path ignoring obstacles is added to the route.

  • pref - intermediate point of the route. You can use this type for all transportation types except for public transport. For public transport, intermediate points are specified in a separate array intermediate_points.

    If you specify multiple pairs of starting and ending points, building a route with intermediate points is not supported.

Intermediate points

Depending on the transportation type, you can specify the following number of intermediate points:

  • For public transport: up to 10 points.
  • For pedestrian routes: up to 3 points.
  • For all transportation types except public transport: up to 8 points.

Public transport

To build a route by public transport with intermediate points, send a POST request to /public_transport/2.0 with the following parameters:

  • source (mandatory parameter) - coordinates of the starting point (latitude and longitude).
  • target (mandatory parameter) - coordinates of the ending point (latitude and longitude).
  • transport (mandatory parameter) - array of public transport types. For example, tram - tram. For the full list of public transport types, see the transport parameter in the API Reference or the Transportation types instruction.
  • intermediate_points - array of intermediate point coordinates (latitude and longitude).
  • locale - language of text descriptions of route elements: English.

Request example:

curl --request POST \
--url 'https://routing.api.2gis.com/public_transport/2.0?key=API_KEY' \
--header 'Content-Type: application/json' \
--data '{
"source":
{
"point":
{
"lat": 55.798227,
"lon": 37.697461
}
},
"target":
{
"point":
{
"lat": 55.821029,
"lon": 37.641507
}
},
"intermediate_points": [
{
"point":
{
"lat": 55.819654,
"lon": 37.663589
}
}
],
"transport": ["tram"],
"locale": "en"
}'

In the response, a comment You have reached an intermediate point. will be added for the intermediate point:

    ...
{
"distance": 0,
"id": "3",
"moving_duration": 0,
"type": "walkway",
"waiting_duration": 0,
"waypoint": {
"comment": "You have reached an intermediate point.",
"name": "",
"subtype": "pedestrian"
}
},
...

Response example:

response.json
[
{
"crossing_count": 0,
"id": "1",
"movements": [
{
"alternatives": [
{
"geometry": [
{
"selection": "LINESTRING(37.697461 55.798227, 37.697219 55.798105)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.697219 55.798105, 37.696846 55.798442, 37.696913 55.798465, 37.697097 55.798530, 37.697169 55.798555)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.697169 55.798555, 37.697179 55.798578, 37.697239 55.798712, 37.697257 55.798766, 37.697271 55.798807, 37.697283 55.798855, 37.697316 55.798894, 37.697373 55.798924, 37.697344 55.799044, 37.697373 55.799165)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.697373 55.799165, 37.697336 55.799173, 37.697319 55.799189, 37.697312 55.799205, 37.697312 55.799216, 37.697311 55.799245, 37.697306 55.799513, 37.697305 55.799548, 37.697340 55.799579, 37.697414 55.799597, 37.697602 55.799600, 37.697758 55.799602)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.697758 55.799602, 37.697797 55.799705, 37.697797 55.799785, 37.697792 55.800052, 37.697707 55.800163, 37.697603 55.800241)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.697603 55.800241, 37.697599 55.800487)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.697599 55.800487, 37.698127 55.800700, 37.698175 55.801181, 37.698172 55.801194, 37.698166 55.801209, 37.698148 55.801220, 37.698123 55.801228, 37.698093 55.801236, 37.698080 55.801276, 37.698069 55.801333, 37.698057 55.801363, 37.698121 55.801383, 37.698177 55.801414, 37.698228 55.801461, 37.698339 55.801460, 37.698442 55.801463, 37.698469 55.801445, 37.698502 55.801435, 37.698546 55.801430, 37.699031 55.801478, 37.699181 55.801497, 37.699362 55.801514, 37.699412 55.801519, 37.699633 55.801539, 37.699757 55.801565, 37.699887 55.801601, 37.700890 55.801933, 37.701170 55.802010, 37.702352 55.802286, 37.703161 55.802510, 37.703468 55.802629, 37.704171 55.802825, 37.704450 55.802867, 37.704570 55.802901, 37.705703 55.803212, 37.705873 55.803259, 37.706145 55.803334, 37.706603 55.803460, 37.706942 55.803561, 37.707241 55.803652, 37.707213 55.803686, 37.707186 55.804016, 37.707151 55.804106, 37.707204 55.804110, 37.707139 55.804288)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.707139 55.804288, 37.707220 55.804366)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.707220 55.804366, 37.707143 55.804574, 37.707098 55.804701, 37.707167 55.804708)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.707167 55.804708, 37.707292 55.804723)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.707292 55.804723, 37.707312 55.804669)",
"z_first": 0,
"z_last": 0
}
]
}
],
"distance": 1205,
"id": "2",
"moving_duration": 867,
"platforms": null,
"routes": null,
"type": "walkway",
"waiting_duration": 0,
"waypoint": {
"comment": "1,3 km on foot",
"name": "",
"subtype": "start"
}
},
{
"alternatives": [
{
"geometry": [
{
"selection": "LINESTRING(37.707312 55.804669, 37.706638 55.806534, 37.706486 55.806866, 37.706486 55.806866, 37.706407 55.807038, 37.706084 55.807743, 37.706035 55.807876, 37.705796 55.808663, 37.705773 55.808723, 37.705744 55.808773, 37.705703 55.808819, 37.705699 55.808823, 37.703964 55.809913, 37.703964 55.809913, 37.703053 55.810485, 37.702896 55.810572, 37.702753 55.810643, 37.702591 55.810720, 37.701972 55.810999, 37.701730 55.811093, 37.701529 55.811163, 37.697667 55.812512, 37.697667 55.812512, 37.697577 55.812544, 37.697468 55.812589, 37.697389 55.812631, 37.697304 55.812685, 37.697201 55.812755, 37.695285 55.814300, 37.695285 55.814300, 37.695073 55.814471, 37.695005 55.814519, 37.694910 55.814576, 37.694437 55.814790, 37.694437 55.814790, 37.694374 55.814818, 37.694374 55.814818, 37.693834 55.815062, 37.692710 55.815512, 37.691279 55.816219, 37.691111 55.816299, 37.690935 55.816377, 37.690742 55.816451, 37.690543 55.816517, 37.689091 55.816899, 37.689091 55.816899, 37.688232 55.817120, 37.688133 55.817135, 37.688044 55.817144, 37.687983 55.817146, 37.687925 55.817140, 37.685300 55.816091, 37.685151 55.816005, 37.685146 55.816002, 37.685043 55.815903, 37.685039 55.815899, 37.684968 55.815746, 37.684968 55.815746, 37.684943 55.815685, 37.684943 55.815679, 37.684943 55.815679, 37.684915 55.815595, 37.684858 55.815490, 37.684811 55.815453, 37.684746 55.815427, 37.684666 55.815413, 37.684585 55.815409, 37.683910 55.815484, 37.683910 55.815484, 37.683906 55.815485, 37.683505 55.815543, 37.683137 55.815632, 37.682842 55.815735, 37.679923 55.817113, 37.679697 55.817198, 37.679697 55.817198, 37.679452 55.817263, 37.679197 55.817316, 37.678881 55.817370, 37.678881 55.817370, 37.676014 55.817855, 37.675427 55.817966, 37.674852 55.818113, 37.670645 55.819328, 37.670645 55.819328, 37.670268 55.819436, 37.670268 55.819436, 37.670210 55.819453, 37.670210 55.819453, 37.668247 55.820018, 37.668247 55.820018, 37.667630 55.820196, 37.667630 55.820196, 37.667327 55.820283, 37.665856 55.820705, 37.665856 55.820705, 37.664176 55.821188, 37.662182 55.821803)"
}
],
"platforms": [
{
"geometry": "POINT(37.707312 55.804669)",
"id": "15"
},
{
"geometry": "POINT(37.706486 55.806866)",
"id": "16"
},
{
"geometry": "POINT(37.703964 55.809913)",
"id": "17"
},
{
"geometry": "POINT(37.697667 55.812512)",
"id": "18"
},
{
"geometry": "POINT(37.694374 55.814818)",
"id": "19"
},
{
"geometry": "POINT(37.689091 55.816899)",
"id": "20"
},
{
"geometry": "POINT(37.684968 55.815746)",
"id": "21"
},
{
"geometry": "POINT(37.678881 55.817370)",
"id": "22"
},
{
"geometry": "POINT(37.670645 55.819328)",
"id": "23"
},
{
"geometry": "POINT(37.662182 55.821803)",
"id": "24"
}
]
}
],
"distance": 3825,
"id": "3",
"moving_duration": 780,
"platforms": {
"names": [
"Телерадиокомпания МИР",
"1-я Прогонная",
"Инновационный университет",
"Богородский храм",
"Богатырский мост",
"Ростокинский проезд",
"Институт иностранных языков",
"Станция юных натуралистов"
]
},
"routes": [
{
"color": "#eb5a2b",
"names": [
"11"
],
"subtype": "tram",
"subtype_name": "tram"
}
],
"type": "passage",
"waiting_duration": 232,
"waypoint": {
"combined": false,
"comment": "",
"name": "Мосгорсуд",
"subtype": "tram"
}
},
{
"alternatives": [
{
"geometry": [
{
"selection": "LINESTRING(37.662182 55.821803, 37.662378 55.821714)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.662378 55.821714, 37.662324 55.821661)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.662324 55.821661, 37.662285 55.821621, 37.662405 55.821584, 37.662567 55.821534, 37.662560 55.821335, 37.662559 55.821287)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.662559 55.821287, 37.662560 55.821164)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.662560 55.821164, 37.662561 55.821115, 37.662564 55.820895)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.662564 55.820895, 37.662692 55.820878, 37.663086 55.820878)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.663086 55.820878, 37.663867 55.820880, 37.664169 55.820779, 37.663880 55.820506, 37.663954 55.820483, 37.664018 55.820462, 37.663787 55.820249, 37.663772 55.820180, 37.662928 55.819379, 37.662881 55.819374, 37.662818 55.819324, 37.662986 55.819268)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.662986 55.819268, 37.663421 55.819121)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.663421 55.819121, 37.663787 55.819467, 37.663852 55.819529)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.663852 55.819529, 37.663589 55.819654)",
"z_first": 0,
"z_last": 0
}
]
}
],
"distance": 529,
"id": "25",
"moving_duration": 410,
"platforms": null,
"routes": null,
"type": "walkway",
"waiting_duration": 0,
"waypoint": {
"comment": "530 m on foot",
"name": "пл. Академика Люльки",
"subtype": "pedestrian"
}
},
{
"distance": 0,
"id": "26",
"moving_duration": 0,
"type": "walkway",
"waiting_duration": 60,
"waypoint": {
"comment": "You have reached an intermediate point.",
"name": "",
"subtype": "pedestrian"
}
},
{
"alternatives": [
{
"geometry": [
{
"selection": "LINESTRING(37.663589 55.819654, 37.663852 55.819528)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.663852 55.819528, 37.663787 55.819467, 37.663421 55.819121)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.663421 55.819121, 37.662992 55.819266)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.662992 55.819266, 37.662818 55.819324, 37.662881 55.819374, 37.662928 55.819379, 37.663772 55.820180, 37.663787 55.820249, 37.664018 55.820462, 37.663954 55.820483, 37.663880 55.820506, 37.664169 55.820779, 37.663867 55.820880, 37.663086 55.820878)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.663086 55.820878, 37.662692 55.820878, 37.662563 55.820895)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.662563 55.820895, 37.662295 55.820896, 37.661553 55.820898)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.661553 55.820898, 37.661502 55.820849)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.661502 55.820849, 37.660780 55.820865, 37.660236 55.820883, 37.660118 55.820923, 37.660049 55.820943)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.660049 55.820943, 37.660037 55.820931, 37.659473 55.820938, 37.659252 55.820961, 37.659102 55.820986, 37.658838 55.821084)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.658838 55.821084, 37.657777 55.821070, 37.656474 55.821072, 37.655753 55.821076, 37.655174 55.821084, 37.654702 55.821088, 37.654642 55.821088, 37.654265 55.821091, 37.653891 55.821093, 37.653423 55.821089)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.653423 55.821089, 37.653421 55.821042, 37.652763 55.821049, 37.652116 55.821056, 37.652115 55.821000, 37.651486 55.821005, 37.650038 55.821016, 37.650038 55.820969, 37.649437 55.820975, 37.648994 55.820976, 37.648695 55.820977)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.648695 55.820977, 37.647823 55.820981, 37.647686 55.820982, 37.647499 55.820983, 37.647497 55.820961, 37.645158 55.820985, 37.644974 55.821008, 37.643750 55.821013, 37.642222 55.821021, 37.642069 55.820892, 37.641883 55.820954, 37.641737 55.821003, 37.641765 55.821037, 37.641777 55.821051, 37.641767 55.821066, 37.641753 55.821076, 37.641595 55.821125, 37.641504 55.821039)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.641504 55.821039, 37.641507 55.821029)",
"z_first": 0,
"z_last": 0
}
]
}
],
"distance": 1771,
"id": "2",
"moving_duration": 1275,
"platforms": null,
"routes": null,
"type": "walkway",
"waiting_duration": 0,
"waypoint": {
"comment": "1,8 km on foot",
"name": "",
"subtype": "start"
}
},
{
"distance": 0,
"id": "3",
"moving_duration": 0,
"type": "walkway",
"waiting_duration": 0,
"waypoint": {
"comment": "You have arrived!",
"name": "",
"subtype": "finish"
}
}
],
"pedestrian": true,
"route_id": "moscow-ctx-back.m9/ctxrouting/17727135410000.00000",
"schedules": [
{
"precise_time": "15:44",
"start_time": 56640,
"start_time_utc": 1772714640,
"type": "precise"
},
{
"precise_time": "15:54",
"start_time": 57240,
"start_time_utc": 1772715240,
"type": "precise"
},
{
"precise_time": "16:04",
"start_time": 57840,
"start_time_utc": 1772715840,
"type": "precise"
},
{
"precise_time": "16:14",
"start_time": 58440,
"start_time_utc": 1772716440,
"type": "precise"
}
],
"total_distance": 7330,
"total_duration": 3624,
"total_walkway_distance": "on foot 21 min",
"transfer_count": 1,
"transport": [
"trolleybus",
"tram",
"suburban_train",
"shuttle_bus",
"river_transport",
"premetro",
"pedestrian",
"monorail",
"metro",
"mcd",
"mcc",
"light_rail",
"light_metro",
"funicular_railway",
"cable_car",
"bus",
"aeroexpress"
],
"waypoints": [
{
"combined": false,
"routes_names": [
"11"
],
"subtype": "tram"
}
]
},
{
"crossing_count": 0,
"id": "27",
"movements": [
{
"alternatives": [
{
"geometry": [
{
"selection": "LINESTRING(37.697461 55.798227, 37.697219 55.798105)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.697219 55.798105, 37.696846 55.798442, 37.696773 55.798416, 37.696651 55.798526, 37.696566 55.798495, 37.696479 55.798464, 37.696468 55.798491, 37.696255 55.798682, 37.696146 55.798780, 37.696077 55.798843, 37.695057 55.799763, 37.694602 55.800173, 37.694537 55.800239, 37.694243 55.800507, 37.694229 55.800526, 37.694197 55.800540, 37.694151 55.800542, 37.692213 55.800149, 37.692207 55.800147, 37.692178 55.800202, 37.692165 55.800246)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.692165 55.800246, 37.692111 55.800420)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.692111 55.800420, 37.691998 55.800791, 37.691872 55.801172)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.691872 55.801172, 37.691668 55.801667, 37.691519 55.802111, 37.691425 55.802391, 37.691121 55.802404, 37.691043 55.802426, 37.690760 55.802501)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.690760 55.802501, 37.690329 55.802565, 37.690284 55.802572, 37.689865 55.802584, 37.689708 55.802600, 37.689474 55.802625, 37.689262 55.802597, 37.689094 55.802576, 37.688655 55.802660)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.688655 55.802660, 37.688643 55.802662)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.688643 55.802662, 37.688763 55.802770)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.688763 55.802770, 37.688736 55.802779)",
"z_first": 0,
"z_last": 0
}
]
}
],
"distance": 943,
"id": "28",
"moving_duration": 678,
"platforms": null,
"routes": null,
"type": "walkway",
"waiting_duration": 0,
"waypoint": {
"comment": "950 m on foot",
"name": "",
"subtype": "start"
}
},
{
"alternatives": [
{
"geometry": [
{
"selection": "LINESTRING(37.688736 55.802779, 37.691783 55.805522, 37.691783 55.805522, 37.691818 55.805554, 37.691845 55.805605, 37.691850 55.805654, 37.691833 55.805706, 37.691801 55.805749, 37.688260 55.808460, 37.688260 55.808460, 37.685191 55.810809, 37.685191 55.810809, 37.685033 55.810930, 37.684952 55.810992, 37.684916 55.811028, 37.684896 55.811062, 37.684892 55.811096, 37.684896 55.811129, 37.684909 55.811162, 37.686836 55.813675, 37.686944 55.813828, 37.686980 55.813929, 37.686960 55.814036, 37.686939 55.814092, 37.686932 55.814099, 37.686852 55.814155, 37.685514 55.815093, 37.685514 55.815093, 37.685416 55.815161, 37.685416 55.815161, 37.685287 55.815223, 37.685095 55.815285, 37.684827 55.815345, 37.683910 55.815484, 37.683910 55.815484, 37.683906 55.815485, 37.683505 55.815543, 37.683137 55.815632, 37.682842 55.815735, 37.679923 55.817113, 37.679697 55.817198, 37.679697 55.817198, 37.679452 55.817263, 37.679197 55.817316, 37.678881 55.817370, 37.678881 55.817370, 37.676014 55.817855, 37.675427 55.817966, 37.674852 55.818113, 37.670645 55.819328, 37.670645 55.819328, 37.670268 55.819436, 37.670268 55.819436, 37.670210 55.819453, 37.670210 55.819453, 37.668247 55.820018, 37.668247 55.820018, 37.667630 55.820196, 37.667630 55.820196, 37.667327 55.820283, 37.665856 55.820705, 37.665856 55.820705, 37.664176 55.821188, 37.662182 55.821803)"
}
],
"platforms": [
{
"geometry": "POINT(37.688736 55.802779)",
"id": "39"
},
{
"geometry": "POINT(37.691783 55.805522)",
"id": "40"
},
{
"geometry": "POINT(37.688260 55.808460)",
"id": "41"
},
{
"geometry": "POINT(37.685191 55.810809)",
"id": "42"
},
{
"geometry": "POINT(37.685514 55.815093)",
"id": "43"
},
{
"geometry": "POINT(37.678881 55.817370)",
"id": "44"
},
{
"geometry": "POINT(37.670645 55.819328)",
"id": "45"
},
{
"geometry": "POINT(37.662182 55.821803)",
"id": "46"
}
]
}
],
"distance": 3279,
"id": "29",
"moving_duration": 600,
"platforms": {
"names": [
"Большая Оленья",
"2-й Ширяевский пер.",
"Большая Ширяевская",
"Ростокинский проезд",
"Институт иностранных языков",
"Станция юных натуралистов"
]
},
"routes": [
{
"color": "#eb5a2b",
"names": [
"25"
],
"subtype": "tram",
"subtype_name": "tram"
}
],
"type": "passage",
"waiting_duration": 661,
"waypoint": {
"combined": false,
"comment": "",
"name": "Майский просек",
"subtype": "tram"
}
},
{
"alternatives": [
{
"geometry": [
{
"selection": "LINESTRING(37.662182 55.821803, 37.662378 55.821714)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.662378 55.821714, 37.662324 55.821661)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.662324 55.821661, 37.662285 55.821621, 37.662405 55.821584, 37.662567 55.821534, 37.662560 55.821335, 37.662559 55.821287)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.662559 55.821287, 37.662560 55.821164)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.662560 55.821164, 37.662561 55.821115, 37.662564 55.820895)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.662564 55.820895, 37.662692 55.820878, 37.663086 55.820878)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.663086 55.820878, 37.663867 55.820880, 37.664169 55.820779, 37.663880 55.820506, 37.663954 55.820483, 37.664018 55.820462, 37.663787 55.820249, 37.663772 55.820180, 37.662928 55.819379, 37.662881 55.819374, 37.662818 55.819324, 37.662986 55.819268)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.662986 55.819268, 37.663421 55.819121)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.663421 55.819121, 37.663787 55.819467, 37.663852 55.819529)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.663852 55.819529, 37.663589 55.819654)",
"z_first": 0,
"z_last": 0
}
]
}
],
"distance": 529,
"id": "47",
"moving_duration": 410,
"platforms": null,
"routes": null,
"type": "walkway",
"waiting_duration": 0,
"waypoint": {
"comment": "530 m on foot",
"name": "пл. Академика Люльки",
"subtype": "pedestrian"
}
},
{
"distance": 0,
"id": "48",
"moving_duration": 0,
"type": "walkway",
"waiting_duration": 0,
"waypoint": {
"comment": "You have reached an intermediate point.",
"name": "",
"subtype": "pedestrian"
}
},
{
"alternatives": [
{
"geometry": [
{
"selection": "LINESTRING(37.663589 55.819654, 37.663852 55.819528)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.663852 55.819528, 37.663787 55.819467, 37.663421 55.819121)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.663421 55.819121, 37.662992 55.819266)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.662992 55.819266, 37.662818 55.819324, 37.662881 55.819374, 37.662928 55.819379, 37.663772 55.820180, 37.663787 55.820249, 37.664018 55.820462, 37.663954 55.820483, 37.663880 55.820506, 37.664169 55.820779, 37.663867 55.820880, 37.663086 55.820878)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.663086 55.820878, 37.662692 55.820878, 37.662564 55.820895)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.662564 55.820895, 37.662561 55.821115, 37.662560 55.821165)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.662560 55.821165, 37.662559 55.821287)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.662559 55.821287, 37.662560 55.821335, 37.662567 55.821534, 37.662405 55.821584, 37.662285 55.821621, 37.662324 55.821661)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.662324 55.821661, 37.662379 55.821714)",
"z_first": 0,
"z_last": 0
}
]
}
],
"distance": 529,
"id": "5",
"moving_duration": 380,
"platforms": null,
"routes": null,
"type": "walkway",
"waiting_duration": 0,
"waypoint": {
"comment": "530 m on foot",
"name": "",
"subtype": "start"
}
},
{
"alternatives": [
{
"geometry": [
{
"selection": "LINESTRING(37.662182 55.821803, 37.658375 55.822966, 37.658375 55.822966, 37.657575 55.823211, 37.652794 55.824836, 37.652402 55.824974, 37.652402 55.824974, 37.652265 55.825022, 37.651428 55.825471, 37.651068 55.825617, 37.650897 55.825687, 37.650698 55.825761, 37.648796 55.826395, 37.648796 55.826395, 37.648505 55.826484, 37.648464 55.826494, 37.648137 55.826562, 37.647230 55.826868, 37.647230 55.826868, 37.646884 55.826966, 37.646611 55.827047, 37.646611 55.827047, 37.645893 55.827260, 37.645893 55.827260, 37.645695 55.827318, 37.645583 55.827334, 37.645447 55.827336, 37.645322 55.827321, 37.645189 55.827290, 37.645083 55.827251, 37.638657 55.823945)"
}
],
"platforms": [
{
"geometry": "POINT(37.662182 55.821803)",
"id": "14"
},
{
"geometry": "POINT(37.658375 55.822966)",
"id": "15"
},
{
"geometry": "POINT(37.652402 55.824974)",
"id": "16"
},
{
"geometry": "POINT(37.648796 55.826395)",
"id": "17"
},
{
"geometry": "POINT(37.645893 55.827260)",
"id": "18"
},
{
"geometry": "POINT(37.638657 55.823945)",
"id": "19"
}
]
}
],
"distance": 1790,
"id": "6",
"moving_duration": 420,
"platforms": {
"names": [
"Бориса Галушкина д.17",
"Ярославская",
"Проспект Мира",
"ВДНХ (Северная)"
]
},
"routes": [
{
"color": "#eb5a2b",
"names": [
"25",
"11"
],
"subtype": "tram",
"subtype_name": "tram"
}
],
"type": "passage",
"waiting_duration": 50,
"waypoint": {
"combined": false,
"comment": "",
"name": "пл. Академика Люльки",
"subtype": "tram"
}
},
{
"alternatives": [
{
"geometry": [
{
"selection": "LINESTRING(37.638657 55.823945, 37.638631 55.823961)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.638631 55.823961, 37.638746 55.824020, 37.639012 55.824157, 37.639305 55.824308)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.639305 55.824308, 37.639349 55.824281, 37.639382 55.824262, 37.639424 55.824235)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.639424 55.824235, 37.639502 55.824188)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.639502 55.824188, 37.639560 55.824152, 37.639459 55.824097, 37.639938 55.823801, 37.640514 55.823445, 37.641224 55.823008, 37.641585 55.822786, 37.641599 55.822592, 37.641617 55.822539, 37.641675 55.822529, 37.641775 55.822496, 37.641858 55.822451, 37.641922 55.822397, 37.641962 55.822336, 37.641975 55.822271, 37.642003 55.822265)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.642003 55.822265, 37.642122 55.822253)",
"z_first": 0,
"z_last": -1
},
{
"selection": "LINESTRING(37.642122 55.822253, 37.643316 55.822132, 37.643282 55.822100)",
"z_first": -1,
"z_last": -1
},
{
"selection": "LINESTRING(37.643282 55.822100, 37.643183 55.822009)",
"z_first": -1,
"z_last": 0
},
{
"selection": "LINESTRING(37.643183 55.822009, 37.643155 55.821980, 37.643203 55.821964, 37.643018 55.821773, 37.642977 55.821735)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.642977 55.821735, 37.642882 55.821644)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.642882 55.821644, 37.642812 55.821579, 37.642669 55.821442, 37.642378 55.821171, 37.642309 55.821107, 37.642222 55.821021, 37.642069 55.820892, 37.641883 55.820954, 37.641737 55.821003, 37.641765 55.821037, 37.641777 55.821051, 37.641767 55.821066, 37.641753 55.821076, 37.641595 55.821125, 37.641504 55.821039)",
"z_first": 0,
"z_last": 0
},
{
"selection": "LINESTRING(37.641504 55.821039, 37.641507 55.821029)",
"z_first": 0,
"z_last": 0
}
]
}
],
"distance": 645,
"id": "20",
"moving_duration": 494,
"platforms": null,
"routes": null,
"type": "walkway",
"waiting_duration": 0,
"waypoint": {
"comment": "650 m on foot",
"name": "Метро ВДНХ · 1F",
"subtype": "pedestrian"
}
},
{
"distance": 0,
"id": "21",
"moving_duration": 0,
"type": "walkway",
"waiting_duration": 0,
"waypoint": {
"comment": "You reach the destination at 16:27.",
"name": "",
"subtype": "finish"
}
}
],
"pedestrian": false,
"route_id": "moscow-ctx-back.m9/ctxrouting/17727135410000.00000",
"schedules": [
{
"precise_time": "15:48",
"start_time": 56880,
"start_time_utc": 1772714880,
"type": "precise"
},
{
"precise_time": "16:02",
"start_time": 57720,
"start_time_utc": 1772715720,
"type": "precise"
},
{
"precise_time": "16:14",
"start_time": 58440,
"start_time_utc": 1772716440,
"type": "precise"
},
{
"precise_time": "16:25",
"start_time": 59100,
"start_time_utc": 1772717100,
"type": "precise"
},
{
"precise_time": "16:12",
"start_time": 58320,
"start_time_utc": 1772716320,
"type": "precise"
},
{
"precise_time": "16:17",
"start_time": 58620,
"start_time_utc": 1772716620,
"type": "precise"
},
{
"precise_time": "16:24",
"start_time": 59040,
"start_time_utc": 1772717040,
"type": "precise"
},
{
"precise_time": "16:27",
"start_time": 59220,
"start_time_utc": 1772717220,
"type": "precise"
}
],
"total_distance": 7715,
"total_duration": 3693,
"total_walkway_distance": "on foot 31 min",
"transfer_count": 1,
"waypoints": [
{
"combined": false,
"routes_names": [
"25"
],
"subtype": "tram"
},
{
"combined": false,
"routes_names": [
"11",
"25"
],
"subtype": "tram"
}
]
}
]

Other transportation types

To build a route with intermediate points for any transportation types except public transport, send a POST request to /routing/7.0.0/global with the following parameters:

  • points (mandatory parameter) - array of route points coordinates: starting, ending, and intermediate points ("type": "pref").

  • transport - transportation type.

  • output - result format:

    • summary - simplified output, only time and route length in the response
    • detailed - full output with route geometry
  • locale - language of text descriptions of route elements: English.

Request example:

curl --request POST \
--url 'https://routing.api.2gis.com/routing/7.0.0/global?key=API_KEY' \
--header 'Content-Type: application/json' \
--data '{
"points": [
{
"lon": "37.582591",
"lat": "55.775364",
"type": "stop",
"start": true
},
{
"lon": "37.610203",
"lat": "55.760126",
"type": "pref"
},
{
"lon": "37.656625",
"lat": "55.765036",
"type": "stop"
}
],
"transport": "driving",
"output": "detailed",
"locale": "en"
}'

Response example:

response.json
{
"message": null,
"query": {
"locale": "en",
"output": "detailed",
"points": [
{
"lat": "55.775364",
"lon": "37.582591",
"start": true,
"type": "stop"
},
{
"lat": "55.760126",
"lon": "37.610203",
"type": "pref"
},
{
"lat": "55.765036",
"lon": "37.656625",
"type": "stop"
}
],
"transport": "driving"
},
"result": [
{
"algorithm": "with traffic jams",
"begin_pedestrian_path": {
"geometry": {
"selection": "LINESTRING(37.582590 55.775363, 37.583086 55.775486)"
}
},
"end_pedestrian_path": {
"geometry": {
"selection": "LINESTRING(37.656553 55.765080, 37.656625 55.765036)"
}
},
"filter_road_types": [
"highway"
],
"id": "3115033847549386999",
"maneuvers": [
{
"comment": "start",
"icon": "start",
"id": "11944540730734223152",
"outcoming_path": {
"distance": 30,
"duration": 13,
"geometry": [
{
"color": "normal",
"length": 9,
"selection": "LINESTRING(37.583086 55.775486, 37.583150 55.775405)",
"style": "normal"
},
{
"color": "slow",
"length": 21,
"selection": "LINESTRING(37.583150 55.775405, 37.583231 55.775307, 37.583253 55.775281, 37.583307 55.775231)",
"style": "normal"
}
],
"names": [
"площадь Тверская Застава"
]
},
"outcoming_path_comment": "30 m straight",
"type": "begin"
},
{
"comment": "Left turn",
"icon": "crossroad_left",
"id": "1345895700718532499",
"outcoming_path": {
"distance": 164,
"duration": 125,
"geometry": [
{
"color": "slow-jams",
"length": 76,
"selection": "LINESTRING(37.583307 55.775231, 37.583561 55.775318, 37.583628 55.775341, 37.583734 55.775385, 37.583827 55.775434, 37.584035 55.775570, 37.584217 55.775689)",
"style": "normal"
},
{
"color": "slow",
"length": 88,
"selection": "LINESTRING(37.584217 55.775689, 37.584347 55.775775, 37.584624 55.775956, 37.584979 55.776188, 37.585058 55.776240, 37.585154 55.776303)",
"style": "normal"
}
],
"names": []
},
"outcoming_path_comment": "150 m straight",
"turn_angle": -92,
"turn_direction": "left",
"type": "crossroad"
},
{
"comment": "Right turn onto 1-я Тверская-Ямская",
"icon": "crossroad_right",
"id": "8106942766737749780",
"outcoming_path": {
"distance": 2372,
"duration": 802,
"geometry": [
{
"color": "slow",
"length": 92,
"selection": "LINESTRING(37.585154 55.776303, 37.585445 55.776157, 37.585492 55.776131, 37.585658 55.776039, 37.586214 55.775714)",
"style": "normal"
},
{
"color": "normal",
"length": 1007,
"selection": "LINESTRING(37.586214 55.775714, 37.588010 55.774663, 37.588280 55.774505, 37.590369 55.773281, 37.590635 55.773126, 37.592026 55.772311, 37.592333 55.772132, 37.594081 55.771108, 37.594993 55.770574, 37.595598 55.770219, 37.595740 55.770136, 37.595903 55.770019, 37.596125 55.769859, 37.596682 55.769461, 37.596711 55.769445, 37.597332 55.769104)",
"style": "normal"
},
{
"color": "slow",
"length": 309,
"selection": "LINESTRING(37.597332 55.769104, 37.598026 55.768722, 37.599143 55.768109, 37.599686 55.767811, 37.600043 55.767616, 37.600420 55.767408, 37.600897 55.767147)",
"style": "normal"
},
{
"color": "slow-jams",
"length": 292,
"selection": "LINESTRING(37.600897 55.767147, 37.601521 55.766805, 37.601900 55.766596, 37.602422 55.766310, 37.603289 55.765833, 37.603830 55.765536, 37.604201 55.765332, 37.604264 55.765298)",
"style": "normal"
},
{
"color": "slow",
"length": 672,
"selection": "LINESTRING(37.604264 55.765298, 37.605221 55.764772, 37.605331 55.764712, 37.605589 55.764564, 37.605755 55.764468, 37.605892 55.764379, 37.605943 55.764346, 37.606052 55.764261, 37.606330 55.764042, 37.607409 55.763195, 37.608277 55.762513, 37.608419 55.762402, 37.608663 55.762210, 37.608964 55.761973, 37.609189 55.761797, 37.609668 55.761364, 37.610581 55.760402)",
"style": "normal"
}
],
"names": [
"1-я Тверская-Ямская"
]
},
"outcoming_path_comment": "2.4 km straight",
"turn_angle": 91,
"turn_direction": "right",
"type": "crossroad"
},
{
"comment": "Right turn onto Брюсов переулок",
"icon": "crossroad_right",
"id": "1748256392467532037",
"outcoming_path": {
"distance": 36,
"duration": 14,
"geometry": [
{
"color": "fast",
"length": 36,
"selection": "LINESTRING(37.610581 55.760402, 37.610340 55.760336, 37.610053 55.760258)",
"style": "archway"
}
],
"names": [
"Брюсов переулок"
]
},
"outcoming_path_comment": "40 m straight",
"turn_angle": 92,
"turn_direction": "right",
"type": "crossroad"
},
{
"comment": "Left turn onto Брюсов переулок",
"icon": "crossroad_left",
"id": "991952759461565641",
"outcoming_path": {
"distance": 52,
"duration": 14,
"geometry": [
{
"color": "ignore",
"length": 52,
"selection": "LINESTRING(37.610053 55.760258, 37.610094 55.760210, 37.610138 55.760158, 37.610173 55.760118, 37.610420 55.759828)",
"style": "living_zone"
}
],
"names": [
"Брюсов переулок"
]
},
"outcoming_path_comment": "50 m straight",
"turn_angle": -90,
"turn_direction": "left",
"type": "crossroad"
},
{
"comment": "U-turn on Брюсов переулок",
"icon": "turn_over_right_hand",
"id": "3937159248075899503",
"outcoming_path": {
"distance": 52,
"duration": 14,
"geometry": [
{
"color": "ignore",
"length": 52,
"selection": "LINESTRING(37.610420 55.759828, 37.610138 55.760158, 37.610094 55.760210, 37.610053 55.760258)",
"style": "living_zone"
}
],
"names": [
"Брюсов переулок"
]
},
"outcoming_path_comment": "50 m straight",
"turn_angle": -180,
"turn_direction": "uturn_left",
"type": "crossroad"
},
{
"comment": "Right turn onto Брюсов переулок",
"icon": "crossroad_right",
"id": "2164172927516240948",
"outcoming_path": {
"distance": 36,
"duration": 14,
"geometry": [
{
"color": "normal",
"length": 20,
"selection": "LINESTRING(37.610053 55.760258, 37.610340 55.760336)",
"style": "archway"
},
{
"color": "fast",
"length": 16,
"selection": "LINESTRING(37.610340 55.760336, 37.610581 55.760402)",
"style": "archway"
}
],
"names": [
"Брюсов переулок"
]
},
"outcoming_path_comment": "40 m straight",
"turn_angle": 90,
"turn_direction": "right",
"type": "crossroad"
},
{
"comment": "Right turn onto Тверская",
"icon": "crossroad_right",
"id": "1157783120792659119",
"outcoming_path": {
"distance": 452,
"duration": 142,
"geometry": [
{
"color": "slow",
"length": 452,
"selection": "LINESTRING(37.610581 55.760402, 37.611732 55.759187, 37.611881 55.759030, 37.612156 55.758740, 37.612480 55.758397, 37.612745 55.758176, 37.613042 55.757957, 37.613061 55.757943, 37.613220 55.757842, 37.613439 55.757702, 37.614188 55.757327, 37.614359 55.757241, 37.614424 55.757209, 37.614692 55.757075)",
"style": "normal"
}
],
"names": [
"Тверская"
]
},
"outcoming_path_comment": "450 m straight",
"turn_angle": 88,
"turn_direction": "right",
"type": "crossroad"
},
{
"comment": "Left turn onto Охотный Ряд",
"icon": "crossroad_left",
"id": "13042238317289628992",
"outcoming_path": {
"distance": 711,
"duration": 151,
"geometry": [
{
"color": "slow",
"length": 25,
"selection": "LINESTRING(37.614692 55.757075, 37.614880 55.756984, 37.615022 55.756943)",
"style": "normal"
},
{
"color": "normal",
"length": 440,
"selection": "LINESTRING(37.615022 55.756943, 37.615076 55.756942, 37.615157 55.756952, 37.615216 55.756962, 37.615276 55.756977, 37.615375 55.757008, 37.615474 55.757045, 37.615885 55.757209, 37.616106 55.757348, 37.617164 55.758021, 37.617490 55.758218, 37.617688 55.758337, 37.617914 55.758435, 37.618154 55.758495, 37.618405 55.758539, 37.618690 55.758588, 37.619878 55.758794, 37.620053 55.758825, 37.620388 55.758883, 37.620854 55.758964)",
"style": "normal"
},
{
"color": "normal",
"length": 188,
"selection": "LINESTRING(37.620854 55.758964, 37.621520 55.759079, 37.622236 55.759179, 37.622780 55.759255, 37.623755 55.759390)",
"style": "normal"
},
{
"color": "slow",
"length": 58,
"selection": "LINESTRING(37.623755 55.759390, 37.624658 55.759515)",
"style": "normal"
}
],
"names": [
"Охотный Ряд"
]
},
"outcoming_path_comment": "700 m straight",
"turn_angle": -60,
"turn_direction": "left",
"type": "crossroad"
},
{
"comment": "Keep right on Новая площадь",
"icon": "crossroad_keep_right",
"id": "14312024842208089264",
"outcoming_path": {
"distance": 477,
"duration": 186,
"geometry": [
{
"color": "slow",
"length": 477,
"selection": "LINESTRING(37.624658 55.759515, 37.625049 55.759532, 37.625210 55.759535, 37.625387 55.759532, 37.625526 55.759521, 37.625663 55.759504, 37.625747 55.759487, 37.625791 55.759478, 37.625904 55.759444, 37.625994 55.759402, 37.626075 55.759353, 37.626542 55.759020, 37.626797 55.758837, 37.627134 55.758596, 37.627309 55.758471, 37.627604 55.758260, 37.627872 55.758068, 37.629510 55.756897, 37.629731 55.756739, 37.629801 55.756689, 37.629850 55.756654, 37.629895 55.756632)",
"style": "normal"
}
],
"names": [
"Новая площадь"
]
},
"outcoming_path_comment": "500 m straight",
"turn_angle": 10,
"turn_direction": "keep_right",
"type": "crossroad"
},
{
"comment": "Left turn onto площадь Ильинские Ворота",
"icon": "crossroad_left",
"id": "14424228281983965650",
"outcoming_path": {
"distance": 1861,
"duration": 558,
"geometry": [
{
"color": "normal",
"length": 572,
"selection": "LINESTRING(37.629895 55.756632, 37.629978 55.756619, 37.630038 55.756617, 37.630106 55.756623, 37.630198 55.756645, 37.630971 55.756953, 37.631358 55.757108, 37.631510 55.757168, 37.631622 55.757199, 37.631670 55.757213, 37.631827 55.757252, 37.631923 55.757272, 37.632087 55.757308, 37.632317 55.757358, 37.632359 55.757366, 37.632614 55.757414, 37.632704 55.757432, 37.633055 55.757485, 37.633207 55.757503, 37.633488 55.757537, 37.633724 55.757566, 37.633783 55.757573, 37.634140 55.757600, 37.634746 55.757634, 37.635261 55.757663, 37.635590 55.757681, 37.635743 55.757690, 37.636312 55.757722, 37.636337 55.757724, 37.636550 55.757739, 37.636752 55.757770, 37.636968 55.757820, 37.637080 55.757845, 37.637735 55.757996, 37.638128 55.758086, 37.638437 55.758157, 37.638642 55.758204)",
"style": "normal"
},
{
"color": "slow",
"length": 297,
"selection": "LINESTRING(37.638642 55.758204, 37.639772 55.758464, 37.639913 55.758496, 37.640505 55.758599, 37.640845 55.758658, 37.641213 55.758722, 37.641348 55.758745, 37.641594 55.758788, 37.641693 55.758805, 37.642116 55.758876, 37.643212 55.759058)",
"style": "normal"
},
{
"color": "normal",
"length": 134,
"selection": "LINESTRING(37.643212 55.759058, 37.643303 55.759069, 37.643928 55.759139, 37.643976 55.759145, 37.644427 55.759197, 37.645136 55.759277, 37.645355 55.759302)",
"style": "normal"
},
{
"color": "slow",
"length": 72,
"selection": "LINESTRING(37.645355 55.759302, 37.646107 55.759386, 37.646278 55.759405, 37.646352 55.759417, 37.646405 55.759425, 37.646523 55.759444)",
"style": "normal"
},
{
"color": "normal",
"length": 519,
"selection": "LINESTRING(37.646523 55.759444, 37.646640 55.759462, 37.647064 55.759528, 37.647326 55.759581, 37.647435 55.759604, 37.647605 55.759639, 37.647686 55.759656, 37.647877 55.759695, 37.648082 55.759738, 37.648147 55.759758, 37.648266 55.759794, 37.648531 55.759893, 37.648620 55.759926, 37.648975 55.760098, 37.649122 55.760169, 37.649457 55.760331, 37.649506 55.760360, 37.649573 55.760399, 37.649617 55.760428, 37.649720 55.760498, 37.649886 55.760610, 37.649948 55.760653, 37.650400 55.760959, 37.650498 55.761026, 37.650552 55.761063, 37.650625 55.761112, 37.650686 55.761152, 37.650723 55.761176, 37.651595 55.761747, 37.651709 55.761822, 37.651900 55.761947, 37.651980 55.761999, 37.652258 55.762182, 37.652370 55.762250, 37.652487 55.762314, 37.652695 55.762420, 37.652816 55.762482)",
"style": "normal"
},
{
"color": "slow",
"length": 267,
"selection": "LINESTRING(37.652816 55.762482, 37.652856 55.762503, 37.653203 55.762681, 37.653603 55.762887, 37.653911 55.763044, 37.654023 55.763099, 37.654131 55.763152, 37.654208 55.763189, 37.654436 55.763298, 37.654489 55.763323, 37.654911 55.763513, 37.655096 55.763596, 37.655188 55.763638, 37.655250 55.763663, 37.655523 55.763774, 37.655742 55.763856, 37.655887 55.763910, 37.655978 55.763942, 37.656208 55.764020)",
"style": "normal"
}
],
"names": [
"площадь Ильинские Ворота"
]
},
"outcoming_path_comment": "1.9 km straight",
"turn_angle": -84,
"turn_direction": "left",
"type": "crossroad"
},
{
"comment": "Left turn onto Садовая-Черногрязская",
"icon": "crossroad_left",
"id": "6149755175139977841",
"outcoming_path": {
"distance": 98,
"duration": 69,
"geometry": [
{
"color": "normal",
"length": 15,
"selection": "LINESTRING(37.656208 55.764020, 37.656416 55.764092)",
"style": "normal"
},
{
"color": "slow-jams",
"length": 83,
"selection": "LINESTRING(37.656416 55.764092, 37.656235 55.764223, 37.656076 55.764339, 37.655591 55.764691)",
"style": "normal"
}
],
"names": [
"Садовая-Черногрязская"
]
},
"outcoming_path_comment": "100 m straight",
"turn_angle": -97,
"turn_direction": "left",
"type": "crossroad"
},
{
"comment": "Right turn",
"icon": "crossroad_right",
"id": "15667144735363679746",
"outcoming_path": {
"distance": 36,
"duration": 10,
"geometry": [
{
"color": "ignore",
"length": 21,
"selection": "LINESTRING(37.655591 55.764691, 37.655782 55.764778, 37.655867 55.764818)",
"style": "living_zone"
},
{
"color": "ignore",
"length": 12,
"selection": "LINESTRING(37.655867 55.764818, 37.656014 55.764887)",
"style": "archway"
},
{
"color": "ignore",
"length": 3,
"selection": "LINESTRING(37.656014 55.764887, 37.656064 55.764909)",
"style": "living_zone"
}
],
"names": []
},
"outcoming_path_comment": "40 m straight",
"turn_angle": 89,
"turn_direction": "right",
"type": "crossroad"
},
{
"comment": "Right turn",
"icon": "crossroad_right",
"id": "14542726908924596478",
"outcoming_path": {
"distance": 93,
"duration": 25,
"geometry": [
{
"color": "ignore",
"length": 93,
"selection": "LINESTRING(37.656064 55.764909, 37.656554 55.764570, 37.656591 55.764558, 37.656635 55.764560, 37.656674 55.764578, 37.656728 55.764601, 37.656741 55.764609, 37.656749 55.764617, 37.656755 55.764630, 37.656755 55.764641, 37.656749 55.764655, 37.656538 55.764857)",
"style": "living_zone"
}
],
"names": []
},
"outcoming_path_comment": "90 m straight",
"turn_angle": 90,
"turn_direction": "right",
"type": "crossroad"
},
{
"comment": "Left turn",
"icon": "crossroad_left",
"id": "11008284284218689129",
"outcoming_path": {
"distance": 21,
"duration": 6,
"geometry": [
{
"color": "ignore",
"length": 21,
"selection": "LINESTRING(37.656538 55.764857, 37.656510 55.764857, 37.656485 55.764865, 37.656303 55.764992)",
"style": "living_zone"
}
],
"names": []
},
"outcoming_path_comment": "20 m straight",
"turn_angle": -46,
"turn_direction": "left",
"type": "crossroad"
},
{
"comment": "Right turn",
"icon": "crossroad_right",
"id": "15296099717473006539",
"outcoming_path": {
"distance": 18,
"duration": 5,
"geometry": [
{
"color": "ignore",
"length": 18,
"selection": "LINESTRING(37.656303 55.764992, 37.656543 55.765075, 37.656553 55.765080)",
"style": "living_zone"
}
],
"names": []
},
"outcoming_path_comment": "20 m straight",
"turn_angle": 91,
"turn_direction": "right",
"type": "crossroad"
},
{
"comment": "finish",
"icon": "finish",
"id": "16377021944685554640",
"outcoming_path_comment": "You have arrived!",
"type": "end"
}
],
"reliability": 1.0,
"route_id": "moscow-cr-back.m9/carrouting/1772714436.198246",
"total_distance": 6509,
"total_duration": 2149,
"type": "carrouting",
"ui_total_distance": {
"unit": "km",
"value": "6.5"
},
"ui_total_duration": "35 min",
"waypoints": [
{
"original_point": {
"lat": 55.77548691400483,
"lon": 37.58308675494588
},
"projected_point": {
"lat": 55.77548691400483,
"lon": 37.58308675494588
},
"transit": false
},
{
"original_point": {
"lat": 55.76012597831172,
"lon": 37.61020303061773
},
"projected_point": {
"lat": 55.76011809336845,
"lon": 37.61017365570794
},
"transit": true
},
{
"original_point": {
"lat": 55.76508099601444,
"lon": 37.65655367382703
},
"projected_point": {
"lat": 55.76508099601444,
"lon": 37.65655367382703
},
"transit": false
}
]
}
],
"status": "OK",
"type": "result"
}